DECLARE SUB CheckMaze ()
DEFINT A-Z
DECLARE SUB PrintMaze ()
DECLARE SUB CreateMaze ()
DECLARE SUB ChangeMaze ()

TYPE square
  l AS INTEGER
  r AS INTEGER
  u AS INTEGER
  d AS INTEGER
  show AS INTEGER
  tp AS INTEGER
END TYPE
DIM SHARED space AS square
DIM SHARED curspc, endMaze, noDisk, goodMaze
CONST FALSE = 0
CONST TRUE = NOT FALSE
CONST path$ = "C:\"
CONST totxy = 9
CONST totspc = 81
RANDOMIZE TIMER
ON ERROR GOTO 0

CreateMaze
DO
  PrintMaze
  ChangeMaze
LOOP UNTIL endMaze = TRUE
KILL path$ + "maze.rnd"
SYSTEM

handler:
  SELECT CASE ERR
    CASE 71
      LOCATE 23, 1
      PRINT "No disk inserted!"
      WHILE INKEY$ = "": WEND
      noDisk = TRUE
      RESUME NEXT
    CASE ELSE
      ERROR ERR
  END SELECT
  RESUME

SUB ChangeMaze

DO
  ke$ = UCASE$(INKEY$)
LOOP WHILE ke$ = ""

OPEN path$ + "maze.rnd" FOR RANDOM AS #1 LEN = LEN(space)
SELECT CASE RIGHT$(ke$, 1)
CASE "M"  'right
  IF curspc MOD totxy <> 0 THEN curspc = curspc + 1
CASE "K"  'left
  IF curspc MOD totxy <> 1 THEN curspc = curspc - 1
CASE "H"  'up
  IF curspc + totxy <= totspc THEN curspc = curspc + totxy
CASE "P"  'down
  IF curspc > totxy THEN curspc = curspc - totxy
CASE CHR$(27)
  LOCATE 19, 1
  INPUT "Enter the file name; push enter to quit; enter 0 to cancel: ", nme$
  IF nme$ = "" THEN
    endMaze = TRUE
  ELSEIF nme$ <> "0" THEN
    CheckMaze
    IF NOT goodMaze THEN
      CLOSE #1
      EXIT SUB
    END IF
    ON ERROR GOTO handler
    OPEN "A:\" + nme$ + ".rnd" FOR RANDOM AS #2 LEN = LEN(space)
    CLOSE #2
    IF noDisk THEN
      CLOSE #1
      EXIT SUB
    END IF
    ON ERROR GOTO 0
    KILL "A:\" + nme$ + ".rnd"
    OPEN "A:\" + nme$ + ".rnd" FOR RANDOM AS #2 LEN = LEN(space)
    FOR i = 1 TO totspc
      GET #1, i, space
      PUT #2, i, space
    NEXT i
    endMaze = TRUE
  END IF
CASE CHR$(32)
  GET #1, curspc, space
  IF space.tp = 4 THEN space.tp = 0 ELSE space.tp = space.tp + 1
  PUT #1, curspc, space
CASE "2"
  GET #1, curspc, space
  IF space.d = 0 THEN space.d = 1 ELSE space.d = 0
  PUT #1, curspc, space
CASE "4"
  GET #1, curspc, space
  IF space.l = 0 THEN space.l = 1 ELSE space.l = 0
  PUT #1, curspc, space
CASE "6"
  GET #1, curspc, space
  IF space.r = 0 THEN space.r = 1 ELSE space.r = 0
  PUT #1, curspc, space
CASE "8"
  GET #1, curspc, space
  IF space.u = 0 THEN space.u = 1 ELSE space.u = 0
  PUT #1, curspc, space
END SELECT

CLOSE

END SUB

SUB CheckMaze

DIM exits, npcs, masters, keys

FOR i = 1 TO totspc
  GET #1, i, space
  SELECT CASE space.tp
    CASE 1
      exits = exits + 1
    CASE 2
      npcs = npcs + 1
    CASE 3
      keys = keys + 1
    CASE 4
      masters = masters + 1
  END SELECT
NEXT i

IF exits = 1 AND npcs = 1 AND keys = 1 AND masters = 4 THEN
  goodMaze = TRUE
ELSE
  goodMaze = FALSE
  LOCATE 22, 1
  PRINT "This maze won't work.  Remember, mazes need 1 each of exits, NPCs,"
  PRINT "keys, and 4 Maze Masters.";
  WHILE INKEY$ = "": WEND
END IF

END SUB

SUB CreateMaze

OPEN path$ + "maze.rnd" FOR RANDOM AS #1 LEN = LEN(space)
FOR i = 1 TO totspc
  space.l = 1
  space.r = 1
  space.u = 1
  space.d = 1
  space.show = 0
  space.tp = 0
  PUT #1, i, space
NEXT i
CLOSE #1
curspc = totspc \ 2 + 1

END SUB

SUB PrintMaze

CLS
LOCATE 5, 1
PRINT "SPACEBAR: change space type"
PRINT "ESC: Save the maze and/or quit"
FOR i = 24 TO 27
  PRINT CHR$(i);
NEXT i
PRINT ": Change selected space"
PRINT "2,4,6,8: Change space walls"

a = 51
LOCATE 8, a
COLOR 1: PRINT TAB(a); "";
COLOR 7: PRINT ": Exit";

LOCATE 9, a
COLOR 4: PRINT TAB(a); "";
COLOR 7: PRINT ": NPC";

LOCATE 10, a
COLOR 14: PRINT TAB(a); "";
COLOR 7: PRINT ": Key";

LOCATE 11, a
COLOR 2: PRINT TAB(a); "";
COLOR 7: PRINT ": Maze Master";

LOCATE 12, a
COLOR 15: PRINT TAB(a); "";
COLOR 7: PRINT ": Selected space";

OPEN path$ + "maze.rnd" FOR RANDOM AS #1 LEN = LEN(space)
a = 0
FOR y = 1 TO totxy
  FOR x = 1 TO totxy
    a = a + 1
    LOCATE 14 - y, 35 + x
    GET #1, a, space
    COLOR 7
    IF a = curspc THEN COLOR 15
    SELECT CASE space.tp
      CASE 1: COLOR 1
      CASE 2: COLOR 4
      CASE 3: COLOR 14
      CASE 4: COLOR 2
    END SELECT
    IF space.l = 1 THEN
      IF space.r = 1 THEN
        IF space.u = 1 THEN
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        ELSE
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        END IF
      ELSE
        IF space.u = 1 THEN
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        ELSE
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        END IF
      END IF
    ELSE
      IF space.r = 1 THEN
        IF space.u = 1 THEN
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        ELSE
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        END IF
      ELSE
        IF space.u = 1 THEN
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        ELSE
          IF space.d = 1 THEN PRINT "" ELSE PRINT ""
        END IF
      END IF
    END IF
  NEXT x
NEXT y
COLOR 7
CLOSE #1

END SUB

